import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // ActionListener
import java.awt.*;        // Cursor
import java.net.*;        // URL
import java.lang.*;       // Class, ClassLoader

/** The super class for all tools for adding model objects in the maodel graph.*/
public abstract class AbstractECFTool implements ECFTool {

	/** The panel that shows model graphs. */
	protected GraphsPanel panelGraphs;

	/** Abstarct constructor. */
	public AbstractECFTool(GraphsPanel panelGraphs) {
		this.panelGraphs = panelGraphs;
	} // AbstractECFTool

	public abstract ImageIcon getImageIcon();
	public abstract ImageIcon getSelectedImageIcon();
	public abstract String getToolTipText();
	public abstract Cursor getMyCursor();

	public void setCursor() {
		panelGraphs.setCursor(getMyCursor());
	} // setCursor

	public void install() {
		panelGraphs.install(this);
	} // install

	public void buttonPressed() {;}                         // From ButtonsPanel
	public void mousePressed(MouseEvent e, int ipanel) {;}  // From LayerPanel
	public void mouseReleased(MouseEvent e, int ipanel) {;} // From LayerPanel
	public void mouseDragged(MouseEvent e, int ipanel) {;}  // From LayerPanel
	public void mouseMoved(MouseEvent e, LayerPanel panel) {;}    // From LayerPanel
	public void paint(Graphics2D g2, int ipanel) {
		double scaleDisplay  = ECFModel.scaleDisplay;
		g2.scale(scaleDisplay,scaleDisplay);
		ECF.modelOpen.paint(g2,ipanel);
	} // paint

} // class AbstractECFTool