import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/** Panel for displaing warning messages and time instance information
* at the top of the main window. */
public class AlertPanel extends JPanel implements DocumentListener {

	/** Label for displaying warning messages. */
	JLabel lblCalcWarning;
	/** Text area for information about each time instance. */
	JTextArea textTimeInstance;
	/** A scroll pane for the text area for information about each time instance. */
	JScrollPane textScrollPane;

	/** Creates the alert panel.*/
	public AlertPanel() {
//		this.timeaxis = timeaxis;
		setLayout(new BorderLayout());
		lblCalcWarning = new JLabel("");
		add(lblCalcWarning,BorderLayout.NORTH);
		textTimeInstance = new JTextArea(2,20);
		textTimeInstance.setText(ECF.timeaxis.getSelectedIncrementDescription());
		textScrollPane = new JScrollPane(textTimeInstance);
		add(textScrollPane,BorderLayout.SOUTH);
		textTimeInstance.getDocument().addDocumentListener(this);// addTextListener(this);
	} // AlertPanel

	/** Clear text in alert panel. */
	public void clear() { textTimeInstance.setText(""); }

	/** Show calculator warning.
	* @param fWarn Flag = true if varning message shall be displayed. */
	public void showCalculatorWarning(boolean fWarn) {
		if (fWarn) {
			lblCalcWarning.setText("Calculator Warning");
			lblCalcWarning.setForeground(Color.red);
			lblCalcWarning.setToolTipText("Check calculator !");
		} // if
		else {
			lblCalcWarning.setText("");
			lblCalcWarning.setForeground(Color.black);
			lblCalcWarning.setToolTipText("");
		} // else
	} // showCalculatorWarning

	/** Updates the text describing the current time increment. */
	public void update() {
		textTimeInstance.setText(ECF.timeaxis.getSelectedIncrementDescription());
	} // update

	/** Sets description of current time increment when changed. */
	public void changedUpdate(DocumentEvent e)  {
		String szDescription = textTimeInstance.getText();
		ECF.timeaxis.setSelectedIncrementDescription(szDescription);
	} // void changedUpdate of DocumentListener

	/** Sets description of current time increment when changed. */
	public void insertUpdate(DocumentEvent e) {
		String szDescription = textTimeInstance.getText();
		ECF.timeaxis.setSelectedIncrementDescription(szDescription);
	} // insertUpdate of DocumentListener

	/** Sets description of current time increment when changed. */
	public void removeUpdate(DocumentEvent e) {
		String szDescription = textTimeInstance.getText();
		ECF.timeaxis.setSelectedIncrementDescription(szDescription);
	} // void removeUpdate of DocumentListener

} // AlertPanel