import java.awt.*;        // FlowLayout
import javax.swing.*;     // JPanel

public class ButtonsPanel extends JPanel {

	protected GraphsPanel panelGraphs;

	ButtonsPanel(GraphsPanel panelGraphs) {
		this.panelGraphs = panelGraphs;
		setLayout(new FlowLayout(FlowLayout.LEFT));
		createButtons();
	} // ButtonsPanel

	protected void createButtons() {

		// Buttons
		ECFButton btn = new ECFButton(this,new PointerTool(panelGraphs));
		add(btn);
		add(new ECFButton(this,new SectorTool(panelGraphs)));
		add(new ECFButton(this,new JunctionTool(panelGraphs)));
		add(new ECFButton(this,new SplitterTool(panelGraphs)));
		add(new ECFButton(this,new ProcessTool(panelGraphs)));
		add(new ECFButton(this,new InputOutputTool(panelGraphs)));
		add(new ECFButton(this,new SourceTool(panelGraphs)));
		add(new ECFButton(this,new TerminalTool(panelGraphs)));
		add(new ECFButton(this,new FlowLineTool(panelGraphs)));
		add(new ECFButton(this,new LabelTool(panelGraphs)));
		add(new ECFDeleteButton(this,new DeleteTool(panelGraphs)));
		btn.doClick();  // Makes the button the default button and selects default tool
	} // createButtons

	public void deselectButtons() {
		Component[] vrbtn = getComponents();
		for (int ibtn=0; ibtn<vrbtn.length; ibtn++) {
			ECFButton btn = (ECFButton)vrbtn[ibtn];
			btn.setSelected(false);
		} // for
	} // deselectButtons

} // class ButtonsPanel
