import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;         // File

public class Calculator extends JDialog implements ActionListener{

	private JButton btnClose;
	private static Calculator THIS = null;
	private static Vector vrieqReplaced = new Vector();
	private static Vector vreq;
	public static Vector vrflow = new Vector();
	public static Vector vrflowratio = new Vector();
	public static Vector vrprice = new Vector();
	public static Vector vrproductivity = new Vector();
	private static int cflow = 0;
	private static int cFlowsPrescribed = 0;
	// Total numbers
	private static JLabel labelNumberOfFlows;
	private static JLabel labelNumberOfFlowsPrescribed;
	private static JLabel labelNumberOfEquationsTotal;
	private static JLabel labelMorePrescribedFlowsLeft;
	private static JLabel labelMorePrescribedFlowsRight;
	// Applied numbers
	private static JLabel labelNumberOfEquationsApplied;
	private static JLabel labelNumberOfEquationsNotApplied;
	// Message text area
	private static TextArea textareaMsg;
	private static Vector vreqNotApplied;
	// Equation system
	private static LinEquSystem eqsys = null;
	// File choosers
	private static JFileChooser chooserText;
	private static JFileChooser chooserExcel;
	private static JFileChooser chooserMatlab;
	private static JFileChooser chooserMaple;
/*
	public static void addFlow(Flow flow) {
		System.out.println("Calculator.addFlow: " + flow);
		vrflow.add(flow);
		//calculate();
	} // addFlow

	public static void removeFlow(Flow flow) {
		vrflow.removeElement(flow);
		//calculate();
	} // removeFlow

	public static void setFlows(Vector vrflow) {
		Calculator.vrflow = vrflow;
	} // setFlows
*/
	public static int getIndexOfFlow(Flow flow) {
		return ECF.getIndexOfFlow(flow);
	} // getIndexOfFlow

	/** Get flow with index iflow.
	* @param iflow Index of flow.
	* @return The flow. */
	public static Flow getFlow(int iflow) {
		return ECF.getFlow(iflow);
	} // getFlow

	public static Vector getFlows() { return ECF.getFlows(); }

	/** Get number of flows in whole model.
	* @return Total number of flows. */
	public static int getNumberOfFlows() { return vrflow.size(); }


	public static void addFlowRatio(FlowRatio flowratio) {
		vrflowratio.add(flowratio);
		//calculate();
	} // addFlowRatio

	public static void addFlowRatios(Vector vrflowratio) {
		Iterator iterflowratio = vrflowratio.iterator();
		while (iterflowratio.hasNext()) {
			FlowRatio flowratio = (FlowRatio)iterflowratio.next();
			Calculator.vrflowratio.add(flowratio);
		} // while flowratio
	 } // addFlowRatios

	public static void removeFlowRatio(FlowRatio flowratio) {
//		System.out.println("Calculator.removeFlowRatio: " + flowratio);
		vrflowratio.removeElement(flowratio);
		//calculate();
	} // removeFlowRatio

	public static Vector getFlowRatios() { return vrflowratio; }


	public static void addPrice(Price price) {
		vrprice.add(price);
		//calculate();
	} // addPrice

	public static void addPrices(Vector vrprice) {
		Iterator iterprice = vrprice.iterator();
		while (iterprice.hasNext()) {
			Price price = (Price)iterprice.next();
			Calculator.vrprice.add(price);
		} // while price
	 } // addPrices

	public static void removePrice(Price price) {
		vrprice.removeElement(price);
		//calculate();
	} // removePrice

	public static Vector getPrices() { return vrprice; }

	public static void addProductivity(Productivity productivity) {
//		System.out.println("Calculator.addProductivity:" + productivity);
		vrproductivity.add(productivity);
		//calculate();
	} // addProductivity

	public static void addProductivities(Vector vrproductivity) {
		Iterator iterproductivity = vrproductivity.iterator();
		while (iterproductivity.hasNext()) {
			Productivity productivity = (Productivity)iterproductivity.next();
			Calculator.vrproductivity.add(productivity);
		} // while productivity
	 } // addProductivities

	public static void removeProductivity(Productivity productivity) {
		vrproductivity.removeElement(productivity);
		//calculate();
	} // removeProductivity

	public static Vector getProductivities() { return vrproductivity; }

	public static void clear() {
		vrflowratio.clear();
		vrprice.clear();
		vrproductivity.clear();
	} // clear

	// Activated by:
	// Calculator.addFlow()
	// Calculator.removeFlow()
	// Calculator.addFlowRatio()
	// Calculator.removeFlowRatio()
	// ECF.decodeXML()
	// ECFNode.connectFlowPath()
	// NodeConnectors.undoAssociation()
	// SectorDialog.actionPerformed() OK-Button
	// SplitterDialog.actionPerformed() OK-Button

	public static void calculate() {

		textareaMsg.setText("");

		// Recollect all variables in order to assure consistancy with model
		// and copy to Calculator.
		ECF.modelTop.collectVariables();
		// Total number of flows
		cflow = vrflow.size();

		Flow flow = null;
		int iflow;
		Iterator iter;
		Iterator iterFlow;
		Iterator iterEq;
		Vector vrFlowDefault;

		ECF.frameMain.showCalculatorWarning(false);
		// Measure time
		long timeStart = System.currentTimeMillis();


		// Set up equation system
		eqsys = new LinEquSystem(cflow);

		// Count prescribed flows and set up a diagonal equation
		// system from flows only
		iter = vrflow.iterator();
		cFlowsPrescribed = 0;
		while (iter.hasNext()) {
			flow = (Flow)iter.next();
			if (flow.isPrescribed()) cFlowsPrescribed++;
			iflow = vrflow.indexOf(flow);
			flow.setIndexOfFlow(iflow);
			flow.resetCalculated();
			LinearEquation eq = new LinearEquation(cflow);
			if (flow.isPrescribed()) {
				// Prescribed flow
				eq.setCoefficient(iflow,1);
				eq.setRightMember(flow.getCalcValuePrescribed());
			} else {
				// Default equation, flow=0
				eq.setCoefficient(iflow,1);
				eq.setRightMember(0.0);
			} // if
			try { eqsys.addEquation(eq); }
			catch(Exception e) {System.out.println(e);}
		} // while

		// Collect node equations
		vreq = new Vector();
		Iterator iterNodes = ECF.modelTop.getNodeIterator();
		while(iterNodes.hasNext()) {
			ECFNode node = (ECFNode)iterNodes.next();
			// Get node equations
			try {
				iterEq = node.getEquationsIterator();
				while(iterEq.hasNext()) {
					LinearEquation eq = (LinearEquation)iterEq.next();
					vreq.add(eq);
				} // while equations
			} catch(Exception e) {
				ECF.frameMain.showCalculatorWarning(true);
				textareaMsg.append("Warning: Equation system was not properly compiled.\n" +
				e.getMessage() + "\n");
				THIS.show();
			} // try catch
		} // while nodes

		// Sort equations according to min index of flow
		Collections.sort(vreq);

		// Add node equations
		int ceqTotal = 0;
		int ceqApplied = 0;
		vreqNotApplied = new Vector();
		vrieqReplaced = new Vector();
		// Get node equations
		try {
			iterEq = vreq.iterator();
			while(iterEq.hasNext()) {
				ceqTotal += 1;
				LinearEquation eq = (LinearEquation)iterEq.next();
				boolean fEquationWasApplied = false;
				int[] vriflow = eq.getFlowIndices();
				for (int ivr=0; ivr<vriflow.length; ivr++) {
					iflow = vriflow[ivr];
					flow = (Flow)vrflow.elementAt(iflow);
					boolean fIsDefault = flow.isDefault();
					try {
						if(fIsDefault) {
							eqsys.replaceEquation(eq,iflow);
							ceqApplied += 1;
							// Remember where equations were replaced
							vrieqReplaced.add(new Integer(iflow));
							flow.setCalculated();
							fEquationWasApplied = true;
							break;
						} // if
					} catch(Exception e) {System.out.println(e);}
					// System.out.println("  eqsys=" + eqsys);
				} // for flows
				if (!fEquationWasApplied) {
					// Remember equations that were not applied
					vreqNotApplied.add(eq);
				} // if
			} // while iterEq.hasNext()
		} catch(Exception ex) {System.out.println(ex);}

		// Show a compact view of equation system
//		System.out.println("\nCalculator.calculate: Equation 1:st stage" + eqsys.toStringCompact());

		// Collect default flows
//		System.out.println("\nCalculator.calculate: Default flows");
		vrFlowDefault = new Vector();
		iterFlow = vrflow.iterator();
		while (iterFlow.hasNext()) {
			flow = (Flow)iterFlow.next();
			if (flow.isDefault()) {
				vrFlowDefault.add(flow);
			} // if
		} // while

		// Add equations that were not applied
		// to default equations positions in equation system
//		System.out.println("\nCalculator.calculate: Add equations that were not applied");
		iterFlow = vrFlowDefault.iterator();
		while (iterFlow.hasNext()) {
			flow = (Flow)iterFlow.next();
			iflow = vrflow.indexOf(flow);
			// Check if remaining equations do not give singular eq. system
			boolean fEquationWasApplied = false;
			iterEq = vreqNotApplied.iterator();
			while (iterEq.hasNext() && !fEquationWasApplied) {
				LinearEquation eq = (LinearEquation)iterEq.next();
				// Add one equation and Solve equation system
				try {
					// Make a clone to test if the equation can be added
					LinEquSystem eqsysClone = (LinEquSystem)eqsys.clone();
					// These two lines may throw an exception because of
					// replace fails or a singular system results
					eqsysClone.replaceEquation(eq,iflow);
					double[] vrflowCalc = eqsysClone.getSolution();
					// If no exception
					eqsys.replaceEquation(eq,iflow);
					ceqApplied += 1;
					// Remember where equations were replaced
					vrieqReplaced.add(new Integer(iflow));
					flow.setCalculated();
					// Remove equation from not applied equations
					vreqNotApplied.remove(eq);
					fEquationWasApplied = true;
				} catch(Exception e1) { // Singular equation system
					// System.out.println("Calculator: " + e1);
				} // try/catch
			} // while
		} // while

		// List equations that were not applied in text area of dialog
		// and check if a priscribed flow can be replaced by that equation.
		if (vreqNotApplied.size()>0) {
			String szErrorMsg = "";
			iterEq = vreqNotApplied.iterator();
			while (iterEq.hasNext()) {
				LinearEquation eq = (LinearEquation)iterEq.next();
				String szNameLayer = ECF.getLayer(eq.getLayerIndex()).getName();
				textareaMsg.append(eq.getDescription() + " was not applied\n");
				// Try to replace prescribed flows
				iterFlow = vrflow.iterator();
				while (iterFlow.hasNext()) {
					flow = (Flow)iterFlow.next();
					if (flow.isPrescribed()) {
						try {
							// Make a clone to test if the equation can replace prescribed flow
							LinEquSystem eqsysClone = (LinEquSystem)eqsys.clone();
							iflow = vrflow.indexOf(flow);
							eqsysClone.replaceEquation(eq,iflow);
							eqsysClone.getSolution();
							textareaMsg.append("Try to relax " + flow + "\n");
						} catch (Exception e2) {
							szErrorMsg = e2.getMessage();
						} // try/catch
					} // if prescribed
				} // while vrflow
			} // while vreqNotApplied
			textareaMsg.append(szErrorMsg);
			ECF.frameMain.showCalculatorWarning(true);
		} // if

		// Copy equation system before solving it.
		LinEquSystem eqsysClone = (LinEquSystem)eqsys.clone();

		// Get solution
		double[] vrflowCalc = null;
		try {
			// Solv equation system
//			System.out.println("Calculator.calculate: Get solution\n " + eqsys);
			vrflowCalc = eqsysClone.getSolution();
			// Set calculated values of flows
			iter = vrflow.iterator();
			while (iter.hasNext()) {
				flow = (Flow)iter.next();
				iflow = vrflow.indexOf(flow);
				flow.setFlowCalculated(vrflowCalc[iflow]);
			} // while
			// Calculate flow ratios
			iter = vrflowratio.iterator();
			while (iter.hasNext()) {
				FlowRatio flowratio = (FlowRatio)iter.next();
				flowratio.calculate();
			} // while
			// Calculate prices
			iter = vrprice.iterator();
			while (iter.hasNext()) {
				Price price = (Price)iter.next();
				price.calculate();
			} // while
			// Calculate productivitys
			iter = vrproductivity.iterator();
			while (iter.hasNext()) {
				Productivity productivity = (Productivity)iter.next();
				productivity.calculate();
			} // while
		}
		catch(EquationSystemException e) { // Singular equation system
			// System.out.println(e);
			textareaMsg.append("Warning: Equation system was not properly solved.\n" + e + "\n");
			THIS.show();
			ECF.frameMain.showCalculatorWarning(true);
			// Try to find a solution with one equatuion less.
			if (e.getReason()!= EquationSystemException.BADLY_CONDITIONED) tryWithOneEquationLess();
		} // try/catch

		// Update window
		// Total number of flows and equations
		labelNumberOfFlows.setText(Integer.toString(cflow));
		labelNumberOfFlowsPrescribed.setText(Integer.toString(cFlowsPrescribed));
		labelNumberOfEquationsTotal.setText(Integer.toString(ceqTotal));

		labelMorePrescribedFlowsRight.setText("");
		int cdegOfFreedom = cflow-cFlowsPrescribed-ceqTotal;
		if (cdegOfFreedom>1)
			labelMorePrescribedFlowsLeft.setText((cdegOfFreedom) +
					" more flows may be prescribed");
		else if (cdegOfFreedom==1)
			labelMorePrescribedFlowsLeft.setText("One more flow may be prescribed");
		else if (cdegOfFreedom==0)
			labelMorePrescribedFlowsLeft.setText("The equation system is fully specified");
		else if (cdegOfFreedom==-1) {
			labelMorePrescribedFlowsLeft.setText("One equation has to be removed or ...");
			labelMorePrescribedFlowsRight.setText("one prescribed flow has to be relaxed");
		} else {
			labelMorePrescribedFlowsLeft.setText((-cdegOfFreedom) +
					" equations have to be removed or");
			labelMorePrescribedFlowsRight.setText((-cdegOfFreedom) +
					" prescribed flows have to be relaxed");
		} // if/else

		// Applied number of flows and equations
		labelNumberOfEquationsApplied.setText(Integer.toString(ceqTotal-vreqNotApplied.size()));
		labelNumberOfEquationsNotApplied.setText(Integer.toString(vreqNotApplied.size()));
		THIS.repaint();

//		long timeElapsed = System.currentTimeMillis()-timeStart;
//		System.out.println("\nCalculator.calculate: Elapsed time=" + timeElapsed + " ms");
	} // calculate

	private static void tryWithOneEquationLess() {
		// Number of replaced equations .
		int ceq = vrieqReplaced.size();
		// System.out.println("Calculator.tryWithOneEquationLess: ceq=" + ceq);
		textareaMsg.append("\nTry to remove one of the following equations:\n");
		for (int ieq=0; ieq<ceq; ieq++) {
			int iflow = ((Integer)vrieqReplaced.elementAt(ieq)).intValue();
			LinearEquation eq = (LinearEquation)vreq.elementAt(ieq);
			// System.out.println("Calculator.tryWithOneEquationLess: iflow=" + iflow + "\n" + eq);
			try {
				// Copy equation system before trying solutions.
				LinEquSystem eqsysClone = (LinEquSystem)eqsys.clone();
				// Default equation, flow=0
				LinearEquation eqDefault = new LinearEquation(cflow);
				eqDefault.setCoefficient(iflow,1);
				eqDefault.setRightMember(0.0);
					// Replace one equation
				eqsysClone.replaceEquation(eqDefault,iflow);
				// Solve equation system
				double[] vrflowTrial = eqsysClone.getSolution();
//				System.out.println("Calculator.tryWithOneEquationLess: replace " + eq);
				textareaMsg.append(eq.getDescription()+ "\n");
			} catch(Exception e) {
				// System.out.println("Calculator.tryWithOneEquationLess: fail");
			}
		} // for

	} //tryWithOneEquationLess


	Calculator(Point pos) {
		super(ECF.frameMain, "ECF Calculator");  // extends JDialog
		THIS = this;
		setLocation(pos);
		setSize(250,400);
		Container pane = getContentPane();

		// Summary panel
		JPanel panelSummary = new JPanel();
		panelSummary.setLayout(new GridLayout(6,2));

		// Total number of flows
		panelSummary.add(new JLabel("Number of flows:"));
		labelNumberOfFlows = new JLabel(Integer.toString(cflow));
		panelSummary.add(labelNumberOfFlows);
		// Total number of flows
		panelSummary.add(new JLabel("Number of prescribed flows:"));
		labelNumberOfFlowsPrescribed = new JLabel(Integer.toString(cFlowsPrescribed));
		panelSummary.add(labelNumberOfFlowsPrescribed);
		// Total number of equations
		panelSummary.add(new JLabel("Number of equations:"));
		labelNumberOfEquationsTotal = new JLabel("0");
		panelSummary.add(labelNumberOfEquationsTotal);
		// Degrees of freedom
		labelMorePrescribedFlowsLeft = new JLabel("0 more flows may be prescribed");
		panelSummary.add(labelMorePrescribedFlowsLeft);
		labelMorePrescribedFlowsRight = new JLabel(" ");
		panelSummary.add(labelMorePrescribedFlowsRight);

		// Applied number of equations
		panelSummary.add(new JLabel("Number of applied equations:"));
		labelNumberOfEquationsApplied = new JLabel("0");
		panelSummary.add(labelNumberOfEquationsApplied);
		// Number of equations that were not applied
		panelSummary.add(new JLabel("Not applied equations:"));
		labelNumberOfEquationsNotApplied = new JLabel("0");
		panelSummary.add(labelNumberOfEquationsNotApplied);

		pane.add(panelSummary,BorderLayout.NORTH);

		// Message panel
		JPanel panelMsg = new JPanel();
		textareaMsg = new TextArea(20,80); // (rows,columns)
		textareaMsg.setEditable(false);
		panelMsg.add(textareaMsg);
		pane.add(panelMsg,BorderLayout.CENTER);

		// Buttons
		JPanel panelButtons = new JPanel();
		panelButtons.setLayout(new FlowLayout());
		btnClose = new JButton("Close");
		btnClose.addActionListener(this);
		panelButtons.add(btnClose);
		pane.add(panelButtons, BorderLayout.SOUTH);

		pack();

		// Make filechoosers
		chooserText = new JFileChooser();
		chooserText.addChoosableFileFilter(new ECFFileFilter("txt"));
		chooserText.setCurrentDirectory(new File("."));
		chooserExcel = new JFileChooser();
		chooserExcel.addChoosableFileFilter(new ECFFileFilter("dat"));
		chooserExcel.setCurrentDirectory(new File("."));
		chooserMatlab = new JFileChooser();
		chooserMatlab.addChoosableFileFilter(new ECFFileFilter("m"));
		chooserMatlab.setCurrentDirectory(new File("."));
		chooserMaple = new JFileChooser();
		chooserMaple.addChoosableFileFilter(new ECFFileFilter("txt"));
		chooserMaple.setCurrentDirectory(new File("."));

	} // Calculator

	/** Export model data as text.
	* @param szNameXMLFile The name of the XML model file. */
	public void exportText(String szNameXMLFile) {
//		System.out.println("Calculator.exportText: szNameXMLFile=" + szNameXMLFile);
		TimeAxis timeaxis = ECF.getTimeAxis();
		Exporter exp = new TextExporter(szNameXMLFile,"txt");
		exp.setTimeHistories(timeaxis,vrflow,vrflowratio,vrprice,vrproductivity);
		exp.export();
	} // exportText

	/** Export model data for import to Excel.
	* @param szNameXMLFile The name of the XML model file. */
	public void exportExcel(String szNameXMLFile) {
//		System.out.println("Calculator.exportExcel: szNameXMLFile=" + szNameXMLFile);
		TimeAxis timeaxis = ECF.getTimeAxis();
		Exporter exp = new ExcelExporter(szNameXMLFile,"dat");
		exp.setTimeHistories(timeaxis,vrflow,vrflowratio,vrprice,vrproductivity);
		exp.export();
	} // exportExcel

	/** Export model data as Matlab script file *.m .
	* @param szNameXMLFile The name of the XML model file. */
	public void exportMatlab(String szNameXMLFile) {
//		System.out.println("Calculator.exportMatlab: szNameXMLFile=" + szNameXMLFile);
		TimeAxis timeaxis = ECF.getTimeAxis();
		Exporter exp = new MatlabExporter(szNameXMLFile,"m");
		exp.setTimeHistories(timeaxis,vrflow,vrflowratio,vrprice,vrproductivity);
		exp.setEqSys(eqsys,vreqNotApplied);
		exp.export();
	} // exportMatlab

	/** Export model data as Maple file.
	* @param szNameXMLFile The name of the XML model file. */
	public void exportMaple(String szNameXMLFile) {
//		System.out.println("Calculator.exportMaple: szNameXMLFile=" + szNameXMLFile);
		TimeAxis timeaxis = ECF.getTimeAxis();
		Exporter exp = new MapleExporter(szNameXMLFile,"mws");
		exp.setTimeHistories(timeaxis,vrflow,vrflowratio,vrprice,vrproductivity);
		exp.setEqSys(eqsys,vreqNotApplied);
		exp.export();
	} // exportMaple

	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==btnClose) {
			hide();
		} // if
	} // actionPerformed

} // class Calculator