import javax.swing.*;

/** The dialog gives the choise of deleting all time dependent data
* or reject deleting. The time axis will be restored to one increment.
* All variables associated with the time axis will be cleared
* from magnitudes and reset to length one.
*/
public class ClearDataDialog {

	/**
	* Opens a dialog for resetting time axis and associated
	* variables. The time axis will have no time specified and
	* unit length. Variables will have all magnitudes erased.
	* @param owner The parent frame of the dialog.
	* @param model The ECFModel to be cleared.
	*/
	public ClearDataDialog() {

		Object[] options = {"Yes","No"};

		int n = JOptionPane.showOptionDialog(ECF.frameMain,
		    "This will clear time axis and all flow rates.\n" +
		      "Do you want to continue?",
		    "Clear time axis and flow data.",
		    JOptionPane.YES_NO_OPTION,
		    JOptionPane.WARNING_MESSAGE,
		    null,     //don't use a custom Icon
		    options,  //the titles of buttons
		    options[0]); //default button title

		if (n==0) ECF.modelTop.clearVariableData();

	} // ClearDataDialog

} // class ClearDataDialog