import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ECFNodeDialog extends JDialog implements ActionListener {

	JTextField txtfldName;
	JButton btnOK;
	JButton btnCancel;
	ECFNode node;
	String szName;
	int clayer =1;
	Checkbox chkboxPrescr[];

	ECFNodeDialog(JFrame owner, ECFNode node, Point pos) {
		super(owner, "Node properties", true);
		this.node = node;
		setLocation(pos);
		szName = node.getName();
		clayer = node.getNoOfLayers();
		chkboxPrescr = new Checkbox[clayer];
		try {makeContentPane();}
		catch(Exception e) {System.out.println(e);}
		pack();
	} // ECFNodeDialog

	protected void makeContentPane() {
		Container pane = getContentPane();
		// Label
		JLabel label = new JLabel("Node Name:");
		pane.add(label,BorderLayout.NORTH);
		// Text field
		txtfldName = new JTextField(szName,20);
		pane.add(txtfldName, BorderLayout.CENTER);
		// Buttons
		btnOK = new JButton("OK");
		btnOK.addActionListener(this);
		btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(this);
		JPanel panelButtons = new JPanel();
		panelButtons.setLayout(new FlowLayout());
		panelButtons.add(btnOK);
		panelButtons.add(btnCancel);
		pane.add(panelButtons, BorderLayout.SOUTH);
	} // makeContentPane

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==btnOK) {
			node.setName(txtfldName.getText());
			dispose();
		} else if(e.getSource()==btnCancel) {
			dispose();
		} // if
	} // actionPerformed

} // class ECFNodeDialog