public class EquationSystemException extends Exception {

	public static int OK = 0;
	public static int BADLY_CONDITIONED = 1;
	public static int OTHER_FAILURE = 2;

	protected int ireason = OK;

	/** Create an exception. */
	EquationSystemException() {
		super();
		ireason = OTHER_FAILURE;
	}

	/** Create an exception.
	* @param szMsg The message to be returned. */
	EquationSystemException(String szMsg) {
		super(szMsg);
		ireason = OTHER_FAILURE;
	}

	/** Create an exception.
	* @param szMsg The message to be returned.
	* @param ireason The index of the reason: OK, BADLY_CONDITIONED or OTHER_FAILURE.*/
	EquationSystemException(String szMsg, int ireason) {
		super(szMsg);
		this.ireason = ireason;
	}

	/** Get the reason for the exception.
	* @return Index of the reason: OK, BADLY_CONDITIONED or OTHER_FAILURE. */
	public int getReason() { return ireason; }


	/** Test the class.
	* @param args No arguments are used. */
	public static void main(String[] args) {
		try {
			throw new EquationSystemException();
		} catch(EquationSystemException e) {
			System.out.println("EquationSystemException: " + e);
		} // try/catch
		try {
			throw new EquationSystemException("Test with only string argument");
		} catch(EquationSystemException e) {
			System.out.println("EquationSystemException: " + e);
		} // try/catch
		try {
			throw new EquationSystemException("Test with string and int argument",
				EquationSystemException.BADLY_CONDITIONED);
		} catch(EquationSystemException e) {
			System.out.println("EquationSystemException: " + e + ", reason = " + e.getReason());
		} // try/catch
	} // main

} // EquationSystemException