import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // MouseListener
import java.awt.*;        // Cursor

public class FlowLineTool extends AbstractECFTool {

	public FlowLineTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // FlowLineTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("FlowLineBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("FlowLineSelectedBtn.gif"));}
	public String getToolTipText() { return "Add flow path item";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		// Add flow path or a copy of flow from clipboard if found in clipboard
		if (!e.isControlDown() || ECF.flowpathClipboard==null)
			// Add flow path and a new flow
			ECF.modelOpen.addFlowPath(ipanel,x,y);
		else {
			Flow flow = ECF.flowpathClipboard.getFlow();
			if (flow.getLayerIndex()==ipanel)
				// Add flow path and a copy of an old flow
				ECF.modelOpen.addFlowPathCopy(ipanel,x,y,flow);
			else {
				// Can not add flow to a different layer
				JOptionPane.showMessageDialog(panelGraphs,
   					"A flow copy cannot be added to a different layer \n",
   					"Trying to copy a flow to a different layer.",
   					JOptionPane.ERROR_MESSAGE);
			} // if/else
		} // if/else
		panelGraphs.repaint();
	} // mousePressed

	public String toString() {return "Flow line tool";};

} // class FlowLineTool
