/* The FractionVariable interface defines methods that are
* common to fractional variables such as price(money/commodity)
* or productivity(output/input).
*/
public interface FractionVariable extends SimpleVariable {

	/** Get Nominator Flow.
	* @return Nominator Flow object. */
	public Flow getFlowNominator();

	/** Get Denominator Flow.
	* @return Denominator Flow object. */
	public Flow getFlowDenominator();

	/** Get Denominator Unit.
	* @return Denominator Unit object. */
	public Unit getUnitDenominator();

	/** Get Nominator Unit.
	* @return Nominator Unit object. */
	public Unit getUnitNominator();

	/** Set Denominator Unit.
	* @param Index of denominator unit. */
	public void setUnitDenominator(int iunitDenominator);

	/** Set Nominator Unit.
	* @param Index of nominator unit. */
	public void setUnitNominator(int iunitNominator);

}// FractionVariable