/**
* An <code>InputFlowOfBranch</code> is a real flow that is an input to
* a production branch. It is an element of a matrix with primary input
* flows in the rows and output to users in the columns.
* The InputFlowOfBranch describes the kind of a resource and the quantity.
* <p>
* Prescribed and calculated InputFlow rates are stored as vectors in
* <A href="Variable.html">Variables</A>.
* The <code>get</code> and <code>set</code> methods operate on the
* the Variable value that corresponds to the current time increment.
*/
public class InputFlowOfBranch extends Flow {

	/** Create a InputFlowOfBranch of resources with ilayer = 0.
	* @param timeaxis The time axis against which the InputFlowOfBranch is plotted.
	*/
	public InputFlowOfBranch() {
		super();
		szName = "InputFlowOfBranch"+iflowName;
	} // InputFlowOfBranch

} // InputFlowOfBranch