import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // MouseListener
import java.awt.*;        // Cursor

public class JunctionTool extends AbstractECFTool {

	public JunctionTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // JunctionTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("JunctionBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("JunctionSelectedBtn.gif"));}
	public String getToolTipText() { return "Add junction";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		ECF.modelOpen.addJunction(ipanel,x,y);
		panelGraphs.repaintAll();
	} // mousePressed

	public String toString() {return "Junction tool";};

} // class JunctionTool
