import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** A dialog for setting the text of a label. */
public class LabelDialog extends JDialog implements ActionListener {

//	JTextField txtfldText;
	JTextArea txtfldArea;
	JButton btnOK;
	JButton btnCancel;
	ExplanatoryLabel label;
	String szText;

	LabelDialog(JFrame owner, ExplanatoryLabel label) {
		super(owner, "Label", true);
		this.label = label;
		Point pos = new Point(owner.getX()+20,owner.getY()+20);
		setLocation(pos);
		szText = label.getText();
		try {makeContentPane();}
		catch(Exception e) {System.out.println(e);}
		pack();
		show();
	} // LabelDialog

	protected void makeContentPane() {
		Container pane = getContentPane();
		// Label
		JLabel label = new JLabel("Label Text:");
		pane.add(label,BorderLayout.NORTH);
		// Text field
//		txtfldText = new JTextField(szText,50);
//		pane.add(txtfldText, BorderLayout.CENTER);
		// Text area
		txtfldArea = new JTextArea(szText,5,50);
		JScrollPane scrollpane = new JScrollPane(txtfldArea);
		pane.add(scrollpane, BorderLayout.CENTER);
		// Buttons
		btnOK = new JButton("OK");
		btnOK.addActionListener(this);
		btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(this);
		JPanel panelButtons = new JPanel();
		panelButtons.setLayout(new FlowLayout());
		panelButtons.add(btnOK);
		panelButtons.add(btnCancel);
		pane.add(panelButtons, BorderLayout.SOUTH);
	} // makeContentPane

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==btnOK) {
			label.setText(txtfldArea.getText());
			dispose();
		} else if(e.getSource()==btnCancel) {
			dispose();
		} // if
	} // actionPerformed

} // class LabelDialog