import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // MouseListener
import java.awt.*;        // Cursor

/** A tool to put a label on a model diagram. */
public class LabelTool extends AbstractECFTool {

	/* Constructor for a label tool.*
	* @param panelGraphs The panel to which the label belongs.*/
	public LabelTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // LabelTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("LabelBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("LabelSelectedBtn.gif"));}
	public String getToolTipText() { return "Add explanatory label.";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		ECF.modelOpen.addLabel(ipanel,x,y);
		panelGraphs.repaint();
	} // mousePressed

	public String toString() {return "Flow line tool";};

} // class LabelTool
