/**
* A model layer.
*/

public class Layer {

	/** The name of the layer. */
	private String szName = "Layer";

	/** Create a model layer.
	* @param szName The name of the layer. */
	public Layer(String szName) {
		this.szName = szName;
	} // Layer

	/** Create a model layer. */
	public Layer() {
	} // Layer

	/**
	* Decode layer from XML code.
	* @param szXMLCode The xml description of this layer.
	*/
	public void decodeXML(String szXMLCode) {
		XMLParser xml = null;
		// Decode XML code
		try {
			while (szXMLCode.length()>0) {
			xml = new XMLParser(szXMLCode);
				String szTag = xml.tag();
				String szSub = xml.sub();
				if (szTag.equals("szName")) szName = szSub;
				szXMLCode = xml.remainder();
			} // while
		} catch(Exception e) {
		} // try/catch
	} // decodeXML

	/** Get the name of the layer.
	* @return The name of the layer. */
	public String getName() {return szName; }

	/** List XML code for this layer.
	* @return XML code. */
	public String listXML(String szBlanks) {
		String szXML = "";
		szXML += "<szName>"+szName+"</szName>";
		return szXML;
	} // listXML

	/** Set the name of the layer
	* @param szName the name of the layer. */
	public void setName(String szName) { this.szName = szName; }

} // Layer