import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LayerDialog extends JDialog implements ActionListener{

	JTextField txtfld;
	JButton btnOK;
	JButton btnCancel;
	Layer layer;

	LayerDialog(JFrame owner, Layer layer, Point pos) {
		super(owner, "Layer properties", true);
		this.layer = layer;
		setLocation(pos);
		String szName = layer.getName();
		Container pane = getContentPane();
		// Label
		JLabel label = new JLabel("Layer Name:");
		pane.add(label,BorderLayout.NORTH);
		// Text field
		txtfld = new JTextField(szName,20);
		pane.add(txtfld, BorderLayout.CENTER);
		// Buttons
		btnOK = new JButton("OK");
		btnOK.addActionListener(this);
		btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(this);
		JPanel panelButtons = new JPanel();
		panelButtons.setLayout(new FlowLayout());
		panelButtons.add(btnOK);
		panelButtons.add(btnCancel);
		pane.add(panelButtons, BorderLayout.SOUTH);
		pack();
		show();
	} // LayerDialog

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==btnOK) {
			layer.setName(txtfld.getText());
			dispose();
		} else if(e.getSource()==btnCancel) {
			dispose();
		} // if
	} // actionPerformed

} // class LayerDialog