import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.util.*;       // Vector

public class LayerFrame extends JInternalFrame {

    protected static int openFrameCount = 0;
    protected static final int xOffset = 30, yOffset = 30;
    protected GraphsPanel panelGraphs;
    protected LayerPanel panel;
    protected String szName;
    protected int index = 0;

    static public void resetFrameCount() {openFrameCount = 0;}

    public LayerFrame(GraphsPanel panelGraphs) {
        super("LayerFrame", // #" + (++openFrameCount),
              true,  //resizable
              false, //closable
              true,  //maximizable
              true); //iconifiable

        this.panelGraphs = panelGraphs;
        index = openFrameCount;
        // Index may be out of range when menu actions File->New and File->Load
        try { String szNameTest = ECF.getLayer(index).getName();
		} catch(Exception e) { System.out.println(e); }
        szName = "Layer #" + index;

		// Put an ECF icon in the frame
		ImageIcon icon = ECFMainFrame.createImageIcon("ECFIcon.gif","ECF icon");
		setFrameIcon(icon);

        //...Create the GUI and put it in the window...
        panel = new LayerPanel(this);
        JScrollPane scrollpane = new JScrollPane(panel);
        getContentPane().add(scrollpane);

        //...Then set the window size or call pack...
        setSize(200,200);
        setTitle(szName);

        //Set the window's location.
        setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
		openFrameCount++;

    } // LayerFrame

    public void install(ECFTool tool) {
		panel.install(tool);
	} // installTool

	public void repaint() {
		// System.out.println("    LayerFrame.repaint: index=" + index);
        // Index may be out of range when menu actions File->New and File->Load
        try { String szNameModelLayer = ECF.getLayer(index).getName();
        	  setTitle(szNameModelLayer);
		} catch(Exception e) { setTitle(szName); }
		super.repaint();
	} // repaint

	public String getName() { return szName; }
	public int getIndex() { return index; };

} // LayerFrame
