import java.awt.*;

public class MultiPainter implements Painter {

	protected Painter first,second;

	public MultiPainter(Painter first, Painter second) throws NullPointerException {
		// EFFECTS: If first or second is null throws NullPointerException;
		//   else set the first and second painter.
		setFirstPainter(first);
		setSecondPainter(second);
	} // MultiPainter

	public void paint(Graphics2D g2, Shape shape) {
		// REQUIRES: g2 and shape are not null.
		// EFFECTS: Paints shape into rendering context g2 using
		//    the first painter followed by the second painter.
		first.paint(g2,shape);
		second.paint(g2,shape);
	} // paint

	public void setFirstPainter(Painter painter) throws NullPointerException {
		// MODIFIES. this.
		// EFFECTS: If painter is null throws NullPointerException;
		//   else set the first painter to painter
		if (painter==null) throw new NullPointerException();
		first = painter;
	} // setFirstPainter

	public Painter getFirstPainter() {
		// EFFECTS: Returns the first painter.
		return first;
	} // getFirstPainter

	public void setSecondPainter(Painter painter) throws NullPointerException {
		// MODIFIES. this.
		// EFFECTS: If painter is null throws NullPointerException;
		//   else set the second painter to painter
		if (painter==null) throw new NullPointerException();
		second = painter;
	} // setSecondPainter

	public Painter getSecondPainter() {
		// EFFECTS: Returns the second painter.
		return second;
	} // getSecondPainter

} // class MultiPainter