import javax.swing.*;     // JDesktopPane
import java.awt.*;        // Cursor
import java.awt.event.*;  // MouseListener

public class PointerTool extends AbstractECFTool {

	public PointerTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // PointerTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("ArrowBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("ArrowSelectedBtn.gif"));}
	public String getToolTipText() { return "Pointer";}
	public Cursor getMyCursor() { return new Cursor(Cursor.DEFAULT_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		ECF.modelOpen.mousePressed(e,ipanel);
		panelGraphs.repaintAll();
	} // mousePressed

	public void mouseReleased(MouseEvent e, int ipanel) {
		ECF.modelOpen.mouseReleased(ipanel);
		panelGraphs.repaintAll();
	} // mouseReleased

	public void mouseDragged(MouseEvent e, int ipanel) {
//		int x = e.getX();
//		int y = e.getY();
		ECF.modelOpen.mouseDraggedTo(e,ipanel);
		panelGraphs.repaintAll();
	} // mouseDragged

	public void mouseMoved(MouseEvent e, LayerPanel panel) {
//		int x = e.getX();
//		int y = e.getY();
		ECF.modelOpen.mouseMovedTo(e,panel);
	} // mouseMoved

	public String toString() {return "Pointer tool";};

} // class PointerTool