import javax.swing.*;     // JDesktopPane
import java.awt.*;        // Cursor
import java.awt.event.*;  // MouseListener

public class SectorTool extends AbstractECFTool {

	public SectorTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // SectorTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("SectorBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("SectorSelectedBtn.gif"));}
	public String getToolTipText() { return "Add sector";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		ECF.modelOpen.addSector(x,y);
		panelGraphs.repaintAll();
	} // mousePressed

	public String toString() {return "Sector tool";};

} // class SectorTool