/* The SimpleVariable interface defines methods that are
* common to variables.
*/
public interface SimpleVariable extends SimpleQuantity{

	/**
	* Tell if a variable has a prescribed magnitude.
	* @return true if PRESCRIBED state, else false.	*/
	public boolean isPrescribed();

	/** Get layer index of the variable. To be implemented by subtypes
	* of variable (flow, etc.).
	* @return Index of layer. */
	public int getLayerIndex();

	/** Set state to PRESCRIBED. */
	public void setPrescribed();

	/** Set flow state to DEFAULT.*/
	public void setDefault();

}// SimpleVariable