import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class SourceDialog extends JDialog implements ActionListener {

	JTextField txtfldName;
	JButton btnOK;
	JButton btnEditSourceFlow;
	Source source;
	String szName;
	int clayer =1;
	Checkbox chkboxPrescr[];

	SourceDialog(JFrame owner, Source source, Point pos) {
		super(owner, "Source properties", true);
		this.source = source;
		setLocation(pos);
		szName = source.getName();
		clayer = source.getNoOfLayers();
		chkboxPrescr = new Checkbox[clayer];
		try {makeContentPane();}
		catch(Exception e) {System.out.println(e);}
		pack();
	} // SourceDialog

	protected void makeContentPane() {
		Container pane = getContentPane();
		// Label
		JLabel label = new JLabel("Source Name:");
		pane.add(label,BorderLayout.NORTH);
		// Text field
		txtfldName = new JTextField(szName,20);
		pane.add(txtfldName, BorderLayout.CENTER);
		// Buttons
		btnOK = new JButton("OK");
		btnOK.addActionListener(this);
		btnEditSourceFlow = new JButton("Edit Source Flow");
		btnEditSourceFlow.addActionListener(this);
		JPanel panelButtons = new JPanel();
		panelButtons.setLayout(new FlowLayout());
		panelButtons.add(btnOK);
		panelButtons.add(btnEditSourceFlow);
		pane.add(panelButtons, BorderLayout.SOUTH);
	} // makeContentPane

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==btnOK) {
			source.setName(txtfldName.getText());
			dispose();
		} else if(e.getSource()==btnEditSourceFlow) {
			new SourceFlowDialog(source.getSourceFlow());
			dispose();
		} // if
	} // actionPerformed

} // class SourceDialog