import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // MouseListener
import java.awt.*;        // Cursor

public class SourceTool extends AbstractECFTool {

	public SourceTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // SourceTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("SourceBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("SourceSelectedBtn.gif"));}
	public String getToolTipText() { return "Add source/sink";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		ECF.modelOpen.addSource(ipanel,x,y);
		panelGraphs.repaintAll();
	} // mousePressed

	public String toString() {return "Source tool";}

} // class SourceTool
