import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // MouseListener
import java.awt.*;        // Cursor

public class SplitterTool extends AbstractECFTool {

	public SplitterTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // SplitterTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("SplitterBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("SplitterSelectedBtn.gif"));}
	public String getToolTipText() { return "Add splitter";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		ECF.modelOpen.addSplitter(ipanel,x,y);
		panelGraphs.repaintAll();
	} // mousePressed

	public String toString() {return "Splitter tool";};

} // class SplitterTool
