import javax.swing.*;     // JDesktopPane
import java.awt.event.*;  // MouseListener
import java.awt.*;        // Cursor

public class TerminalTool extends AbstractECFTool {

	public TerminalTool(GraphsPanel panelGraphs) {
		super(panelGraphs);
	} // TerminalTool

	// Create ImageIcons, any class "ECFMainFrame" will do.
	public ImageIcon getImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("TerminalBtn.gif"));}
	public ImageIcon getSelectedImageIcon() {
		return new ImageIcon(ECFMainFrame.class.getResource("TerminalSelectedBtn.gif"));}
	public String getToolTipText() { return "Add terminal";}
	public Cursor getMyCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR);}

	public void mousePressed(MouseEvent e, int ipanel) {
		double scaleDisplay = ECFModel.scaleDisplay;
		int x = (int)(e.getX()/scaleDisplay);
		int y = (int)(e.getY()/scaleDisplay);
		ECF.modelOpen.addTerminal(ipanel,x,y);
		panelGraphs.repaintAll();
	} // mousePressed

	public String toString() {return "Terminal tool";};

} // class TerminalTool
