import java.awt.*;        // Canvas, Graphics

/** Canvas for plotting a time axis.
*/
public class TimeAxisCanvas extends Canvas {

	int width;
	int height = 80;
	TimeAxis timeaxis;

	/** Create a canvas for plotting a timeaxis.
	* @param width The width (pixels) of the canvas
	* @param timeaxis The time axis to be plotted
	*/
	TimeAxisCanvas(int width, TimeAxis timeaxis) {
		this.width = width;
		this.timeaxis= timeaxis;
		setSize(width,height);
		setBackground(Color.white);
	} // TimeAxisCanvas

	/** Set the time axis of the canvas.
	* @param timeaxis The time axis to be plotted
	*/
	public void setTimeAxis(TimeAxis timeaxis) { this.timeaxis= timeaxis; }

	/** Paint time axis with a yellow bar to indicate original part before extending
	* @param g Graphics context
	*/
	public void paint(Graphics g) {
		int xAxisStart = 40;
		int xAxisEnd = width-20;
		timeaxis.paint(g, height-40, width-50, height-50, true); // with yellow bar
	} // paint

} // TimeAxisCanvas
