import java.awt.*;        // Canvas, Graphics

/** A generic canvas for painting variable time histories. */
public class VariableCanvas extends Canvas {

	int width;
	int height = 260;
	Variable variable = null;

	/** Creates a variabel canvas.
	* @param width = The width of the canvas (pixels).
	* @param variable The variable to be painted. */
	public VariableCanvas(int width, Variable variable) {
		this.width = width;
		this.variable= variable;
		setSize(width,height);
		setBackground(Color.white);
	} // VariableCanvas

	// public void setProperty(Variable variable) { this.variable= variable; }

	/** Paints the time history of the variable.
	* @param g The graphics context. */
	public void paint(Graphics g) {
		if (variable==null) return;
		int yOrigin = height-60;
		int heightXAxis = yOrigin-20;
		int xOrigin = 20;
		int widthYAxis = width-xOrigin-50;
		variable.paint(g, xOrigin, yOrigin, widthYAxis, heightXAxis);
	} // paint

} // VariableCanvas
